﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WineFermentationAITool.LibFiles
{
    public class Layer
    {
        public int LayerSize;
        public Neuron[] Neurons;

        public Layer(int CurrLayerSize, int PrevLayerSize, bool isInLayer = false)
        {
            this.LayerSize = CurrLayerSize;
            Neurons = new Neuron[LayerSize];
            for (int neuron = 0; neuron < Neurons.Length; neuron++)
            {
                Neurons[neuron] = new Neuron(PrevLayerSize, isInLayer);
            }
        }
        public Layer(int CurrLayerSize, int PrevLayerSize, double[,] Wga, double[] BiasGa)
        {
            this.LayerSize = CurrLayerSize;
            Neurons = new Neuron[LayerSize];
            double[] W = new double[PrevLayerSize];

            for (int neuron = 0; neuron < Neurons.Length; neuron++)
            {
                for (int i = 0; i < PrevLayerSize; i++)
                {
                    W[i] = Wga[neuron, i];
                }
                Neurons[neuron] = new Neuron(PrevLayerSize, W, BiasGa[neuron]);
            }
        }

        public Neuron Neuron
        {
            get => default(Neuron);
            set
            {
            }
        }
    }
}
