﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WineFermentationAITool.LibFiles
{
    public class Neuron
    {
        public int NumOfWeights;
        public double Bias;
        public double Out;
        public double[] W;
        
        public Neuron(int numOfWeights, bool isInLayer = false)
        {
            this.NumOfWeights = numOfWeights;      
            InitWeightsRandom(numOfWeights, isInLayer);
        }
        public Neuron(int numOfWeights, double[] Wga, double biasGa)
        {
            this.NumOfWeights = numOfWeights;
            InitWeightsGA(Wga, biasGa);
        }
        public void InitWeightsGA(double[] Wga, double biasGa)
        {
            try
            {
                this.W = new double[NumOfWeights];
                for (int w = 0; w < W.Length; w++)
                {
                    this.W[w] = Wga[w];
                }
                this.Bias = biasGa;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }
        public void InitWeightsRandom(int numOfWeights, bool isInLayer)
        {
            try
            {
                Random rand = new();
                int mean = 0;
                double stdDist = Math.Sqrt(2.0 / (numOfWeights + 1));
                this.W = new double[numOfWeights];
                if (isInLayer)
                {
                    //for in layer, weights are initialized to 1 so that the input stays unchanged
                    W = Enumerable.Repeat(1.0, numOfWeights).ToArray();
                    this.Bias = 0;
                }
                else
                {
                    for (int w = 0; w < W.Length; w++)
                    {
                        this.W[w] = rand.NextDouble(); //MathUtils.GetRandGaussianVal(mean, stdDist);
                    }
                    this.Bias = 0;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }
    }
}
