﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MathNet.Numerics.Distributions;

namespace WineFermentationAITool.LibFiles
{
    public static class Constants
    {
        public const int cInLayer = 4;
        public const int cOutLayer = 2;
        public const int cMaxIterations = 2000000;
        public const int cError = -1;
        public const double cMaxDataValue = 226;
        public const double cMinDataValue = 0;
        public const int cNumOfDataSets = 4;
        public const string XAVIER = "xavier";
        public const string GA = "ga";
        public const string PSO = "pso";
        public const string LOAD = "LOAD";
        public const string SAVE = "SAVE";
        public const int MAX_NUM_OF_THREADS = 8;
    }
    public static class MathUtils
    {
        public static Random Rand = new Random();
        public static double GetRandGaussianVal(double mean, double stdDev)
        {
            Normal normalDist = new Normal(mean, stdDev);
            return normalDist.Sample();
        }
        public static void Swap<T>(ref T lhs, ref T rhs)
        {
            T temp = lhs;
            lhs = rhs;
            rhs = temp;
        }
        public static double GetRandProbability()
        {
            return Rand.NextDouble() * (1 + Double.Epsilon);
        }

        public static double NormalizeData(double val, double oldMin, double oldMax, double newMin, double newMax)
        {
            return (newMin + ((val - oldMin) * (newMax - newMin)) / (oldMax - oldMin));
        }
    }
}
