using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Http;
using Newtonsoft.Json;
using WineFermentationAITool.Models;
using Microsoft.AspNetCore.Hosting;
using System.IO;

namespace WineFermentationAITool.Pages.Forms
{
    public class GeneticAlgorithmFormModel : PageModel
    {
        [BindProperty]
        public GeneticAlgorithmModel GA_Model { get; set; }

        public IFormFile UploadFiles { get; set; }
        public IFormFile UploadWeightFile { get; set; }

       // private readonly IWebHostEnvironment _he;

        public GeneticAlgorithmFormModel(IWebHostEnvironment he)
        {
          //  _he = he;
        }
        public IActionResult OnGet()
        {
            if (Request.Headers["Referer"].ToString() == "")
            {
                return RedirectToPage("/Index");
            }

            var GA_string = HttpContext.Session.GetString("GA_Model");

            GA_Model = GA_string == null ? default(GeneticAlgorithmModel) : JsonConvert.DeserializeObject<GeneticAlgorithmModel>(GA_string);
            return Page();
        }
        public async Task<IActionResult> OnPostNext()
        {
            if (GA_Model.weightsAction == "LOAD")
            {
                //var weightsLoadFileUpload = Path.Combine(_he.ContentRootPath, "Files", UploadWeightFile.FileName);
                var weightsLoadFileUpload = Path.Combine(@"D:\Work\MAPIoT\WineFermentationSite\", "Files", UploadWeightFile.FileName);
                using (var fs = new FileStream(weightsLoadFileUpload, FileMode.Create))
                {
                    await UploadWeightFile.CopyToAsync(fs);
                    ViewData["Message"] = "The Selected File " + UploadWeightFile.FileName + " Is Uploaded Successfully";
                    GA_Model.weightsFileName = UploadWeightFile.FileName;
                }
            }
            HttpContext.Session.SetString("GA_Model", JsonConvert.SerializeObject(GA_Model));
            return RedirectToPage("/Forms/TrainTestForm");
        }
        public IActionResult OnPostPrevious()
        {
            HttpContext.Session.SetString("GA_Model", JsonConvert.SerializeObject(GA_Model));
            return RedirectToPage("/Forms/NeuralNetworkForm");
        }
    }
}
