using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Http;
using Newtonsoft.Json;
using WineFermentationAITool.Models;
using WineFermentationAITool.LibFiles;

namespace WineFermentationAITool.Pages.Forms
{
    public class NeuralNetworkFormModel : PageModel
    {
        [BindProperty]
        public NeuralNetworkModel NN_Model { set; get; }
        public IActionResult OnGet()
        {
            if (Request.Headers["Referer"].ToString() == "")
            {
                return RedirectToPage("/Index");
            }
            var NN_string = HttpContext.Session.GetString("NN_Model");

            NN_Model = NN_string == null ? default : JsonConvert.DeserializeObject<NeuralNetworkModel>(NN_string);
            return Page();
        }
        public IActionResult OnPost()
        {
            // restore values received from trainTestForm (if there are some)
            var NN_string = HttpContext.Session.GetString("NN_Model");
            var NN_Temp_Model = NN_string == null ? default(NeuralNetworkModel) : JsonConvert.DeserializeObject<NeuralNetworkModel>(NN_string);

            if (NN_Temp_Model != null)
            {
                NN_Model.IsTrainingSet = NN_Temp_Model.IsTrainingSet;
                NN_Model.DataSets = NN_Temp_Model.DataSets;
            }
            HttpContext.Session.SetString("NN_Model", JsonConvert.SerializeObject(NN_Model));

            if (NN_Model.InitType == Constants.XAVIER)
            {
                return RedirectToPage("/Forms/TrainTestForm");
            }
            else if (NN_Model.InitType == Constants.GA)
            {
                return RedirectToPage("/Forms/GeneticAlgorithmForm");
            }
            else if (NN_Model.InitType == Constants.PSO)
            {
                return RedirectToPage("/Forms/ParticleSwarmOptimizationForm");
            }
            else
            {
                //TODO: add error page
                return RedirectToPage("");
            }
        }
    }
}
