using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Newtonsoft.Json;
using WineFermentationAITool.Models;

namespace WineFermentationAITool.Pages.Forms
{
    public class ParticleSwarmOptimizationFormModel : PageModel
    {
        [BindProperty]
        public ParticleSwarmOptimizationModel PSO_Model { get; set; }
        [BindProperty]
        public IFormFile UploadFiles { get; set; }

       // private readonly IWebHostEnvironment _he;
        public ParticleSwarmOptimizationFormModel(IWebHostEnvironment he)
        {
          //  _he = he;
        }
        public IActionResult OnGet()
        {
            if (Request.Headers["Referer"].ToString() == "")
            {
                return RedirectToPage("/Index");
            }

            var PSO_string = HttpContext.Session.GetString("PSO_Model");

            PSO_Model = PSO_string == null ? default(ParticleSwarmOptimizationModel) : JsonConvert.DeserializeObject<ParticleSwarmOptimizationModel>(PSO_string);
            return Page();
        }
        public async Task<IActionResult> OnPostNext()
        {
            if (PSO_Model.weightsAction == "LOAD")
            {
                //var weightsLoadFileUpload = Path.Combine(_he.ContentRootPath, "Files", UploadFiles.FileName);
               
                var weightsLoadFileUpload = Path.Combine(@"D:\Work\MAPIoT\WineFermentationSite\", "Files", UploadFiles.FileName);
                using (var fs = new FileStream(weightsLoadFileUpload, FileMode.Create))
                {
                    await UploadFiles.CopyToAsync(fs);
                    ViewData["Message"] = "The Selected File " + UploadFiles.FileName + " Is Uploaded Successfully";
                    PSO_Model.weightsFileName = UploadFiles.FileName;
                }
            }
            HttpContext.Session.SetString("PSO_Model", JsonConvert.SerializeObject(PSO_Model));
            return RedirectToPage("/Forms/TrainTestForm");
        }
        public IActionResult OnPostPrevious()
        {
            HttpContext.Session.SetString("PSO_Model", JsonConvert.SerializeObject(PSO_Model));
            return RedirectToPage("/Forms/NeuralNetworkForm");
        }
    }
}
