﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WineFermentationAITool.Pages
{
    public class IndexModel : PageModel
    {
        private readonly ILogger<IndexModel> _logger;
        
        [BindProperty(SupportsGet = true)]
        public string City { get; set; }

        public IndexModel(ILogger<IndexModel> logger)
        {
            _logger = logger;
        }

        public void OnGet()
        {
            if (string.IsNullOrWhiteSpace(City))
            {
                City = "The Web";
            }
        }

        public IActionResult OnPostConfigTool()
        {
            return RedirectToPage("/Forms/NeuralNetworkForm");
        }
        public IActionResult OnPostPredictTool()
        {
            return RedirectToPage("/Forms/PredictParamsForm");
        }
    }
}
